﻿

unit Punktentferner;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, StdCtrls, ExtCtrls, ComCtrls, Forms, Controls, LResources,
  Dialogs, ColorTools, Graphics, OPBitmap, LCLType, lazBridge;

type
 TBitmapArray = Array of TBitmap;
 PBitmapArray = ^TBitmapArray;
 TPunktentferner = class(TComponent)
  private
   Box         : TScrollBox;
   Headline    : TLabel;
   AbweichungL : TLabel;
   AbweichungE : TEdit;
   AbweichungT : TTrackBar;
   GroesseL    : TLabel;
   GroesseE    : TEdit;
   SelbeFarbeC : TCheckBox;
   Start       : TButton;
   Progress    : TProgressBar;

   Abweichung : Byte;
   Groesse    : Word;
   SelbeFarbe : Boolean;

   Bitmaps   : PBitmapArray;
   Pos       : Integer;
   PosRead   : TMethod;
   PosWrite  : TMethod;
   GetColor  : TMethod;
   Operating : Boolean;
   Closed    : Boolean;
   function DoFilter(Bild : TBitmap; MAbweichung,PAbweichung : Byte;_Groesse : Word; _FarbeEgal,_SelbeFarbe : Boolean; _Punktfarbe : BGRAColor) : TBitmap;
   procedure AbweichungTChange(Sender : TObject);
   procedure AbweichungEChange(Sender : TObject);
   procedure GroesseEChange(Sender : TObject);
   procedure SelbeFarbeCChange(Sender : TObject);
   procedure StartClick(Sender : TObject);
  public
   Vorschau : TImage;
   constructor Create(_Owner : TComponent; Choose,_Box : TScrollBox; ChooseAnchor : TImage; _Bitmaps : PBitmapArray; _PosRead,_PosWrite,_GetColor : pointer);
   procedure Show(Sender : TObject);
   procedure InputColor(Color : BGRAColor);
   procedure Actualize;
   procedure Free;
 end;

implementation


type
 TPixCast = Array [0..1] of BGRAColor;
 PPixCast = ^TPixCast;
 TPosRead = function : integer of object;
 TPosWrite = procedure(Pos : integer) of object;
 TGetColor = procedure(Callback : TMethod) of object;

const
 Steps = 8;
 _Steps = 4;

function EditToInt(Edit : TEdit) : integer;
var i : integer;
begin
 Edit.Color := $FFFFFF;
 Result := 0;
 if (Edit.Text = '') or (Edit.Text = '-') then exit;
 for i := 1 to Length(Edit.Text) do begin
  if (Edit.Text[i] <> '0') and
   (Edit.Text[i] <> '1') and
   (Edit.Text[i] <> '2') and
   (Edit.Text[i] <> '3') and
   (Edit.Text[i] <> '4') and
   (Edit.Text[i] <> '5') and
   (Edit.Text[i] <> '6') and
   (Edit.Text[i] <> '7') and
   (Edit.Text[i] <> '8') and
   (Edit.Text[i] <> '9') and
   (Edit.Text[i] <> '-') then begin Edit.Color := $A0A0FF; exit; end;
  if (Edit.Text[i] = '-') and (i <> 1) then begin Edit.Color := $A0A0FF; exit; end;
 end;
 Result := StrToInt(Edit.Caption);
end;

constructor TPunktentferner.Create(_Owner : TComponent; Choose,_Box : TScrollBox; ChooseAnchor : TImage; _Bitmaps : PBitmapArray; _PosRead,_PosWrite,_GetColor : pointer);
begin
 inherited Create(_Owner);
 Closed := false;
 Bitmaps := _Bitmaps;
 Pos := -1;
 PosRead.Code := _PosRead;
 PosRead.Data := _Owner;
 PosWrite.Code := _PosWrite;
 PosWrite.Data := _Owner;
 GetColor.Code := _GetColor;
 GetColor.Data := _Owner;
 Operating := false;

 Box := _Box;
 Vorschau := TImage.Create(self);
 Vorschau.Parent := Choose;
 Vorschau.Top := 3;
 Vorschau.Left := 3;
 Vorschau.AnchorToNeighbour(akLeft,3,ChooseAnchor);
 Vorschau.Width := 80;
 Vorschau.Height := 80;
 Vorschau.Stretch := true;
 Vorschau.OnClick := @Show;
 Vorschau.Picture.LoadFromLazarusResource('Punktentferner');

 Abweichung := 50;
 SelbeFarbe := true;
 Groesse := 6;
end;

function TPunktentferner.DoFilter(Bild : TBitmap; MAbweichung,PAbweichung : Byte; _Groesse : Word; _FarbeEgal,_SelbeFarbe : Boolean; _Punktfarbe : BGRAColor) : TBitmap;
var
 Pic1        : TCanvasOPBitmap;
 x,y         : integer;
 i,j,k,a     : integer;
 LastUpper   : integer;
 LastLower   : integer;
 Max,Min     : TPoint;
 lines1      : Array of PPixCast;
 s           : single;
 C1,C2,Cp    : BGRAColor;
 FoundPoint  : Boolean;
 //Pix           : BGRAColor;

function _CompareColors : Boolean;    // Noch nicht fertig!
begin
 Result := true;
end;
function _IsPartOfPoint : Boolean;
var
 A : single;
begin
 Result := false;
 if (Abs(C1.R - C2.R) > MAbweichung) or (Abs(C1.G - C2.G) > MAbweichung) or (Abs(C1.B - C2.B) > MAbweichung) then Result := true
 else exit;
{ if (Cp.R - C2.R <> 0) then begin
  A := (C1.R - C2.R) / (Cp.R - C2.R);
  if (abs((1-A) * C2.G + A * Cp.G - C1.G) > PAbweichung) then Result := false;
  if (abs((1-A) * C2.B + A * Cp.B - C1.B) > PAbweichung) then Result := false;
 end;{ else if (PColor.G + C2.G <> 0) then begin
  A := (C1.G - PColor.G) / (PColor.G + C2.G);
  if (abs((1-A) * PColor.R + A * C2.R - C1.R) > PAbweichung) then Result := false;
  if (abs((1-A) * PColor.B + A * C2.B - C1.B) > PAbweichung) then Result := false;
 end else if (PColor.B + C2.B <> 0) then begin
  A := (C1.B - PColor.B) / (PColor.B + C2.B);
  if (abs((1-A) * PColor.R + A * C2.R - C1.R) > PAbweichung) then Result := false;
  if (abs((1-A) * PColor.G + A * C2.G - C1.G) > PAbweichung) then Result := false;
 end; }    }
end;
begin
 if (Operating) then exit;
 Operating := true;
 Result := TBitmap.Create;

 // Bild laden
 if (Bild = nil) then exit;
 Pic1 := TCanvasOPBitmap.Create;
 Pic1.Height := Bild.Height;
 Pic1.Width := Bild.Width;
 AssignBitmapToOPBitmap(Bild,Pic1);
 if (Pic1.PixelFormat <> pf32bit) then exit;
 SetLength(Lines1,Pic1.Height);

 // Punkte entfernen
 Progress.Position := Round(10 / 100 * Progress.Width);
 for y := 0 to Pic1.Height - 1 do Lines1[y] := Pic1.ScanLine[y];
 for y := 0 to Pic1.Height - 1 do begin
  for x := 1 to Pic1.Width - 2 do begin
   C1 := Lines1[y]^[x];
   C2 := Lines1[y]^[x-1];
   FoundPoint := false;
   if (_IsPartOfPoint) then begin
    C2 := _Punktfarbe;
    if (_FarbeEgal) or (_CompareColors) then begin
     FoundPoint := true;
     C2 := Lines1[y]^[x-1];
     Cp := C1;
     LastUpper := y;
     LastLower := y;
     Max.Y := y;
     Min.Y := y;
     Max.X := -1;
     Min.X := -1;
     a := 0;
     for i := x to Pic1.Width - 1 do begin
      k := y;
      for j := y to Pic1.Height - 1 do begin
       C1 := Lines1[j]^[i];
       if (not _IsPartOfPoint) then break
       else begin
        if (j > LastLower) then begin
         C1 := Lines1[j]^[i-1];
         if (_IsPartOfPoint) then FoundPoint := false;
        end;
        k := j;
        inc(a);
       end;
      end;
      for j := j to LastLower do begin
       C1 := Lines1[j]^[i];
       if (_IsPartOfPoint) then FoundPoint := false;
      end;
      if (k >= Min.Y) then begin
       Min.Y := k;
       Min.X := i;
       if (_SelbeFarbe) and (Min.Y < Pic1.Height - 2) then begin
        C1 := Lines1[Min.Y + 1]^[Min.X - 1];
        if (Abs(C1.R - C2.R) > MAbweichung) or (Abs(C1.G - C2.G) > MAbweichung) or (Abs(C1.B - C2.B) > MAbweichung) then FoundPoint := false;
       end;
      end;
      if (Min.X >= 0) and (i > Min.X) then begin
       if (k > LastLower) then FoundPoint := false;
       if (_SelbeFarbe) and (k < LastLower) then begin
        C1 := Lines1[LastLower + 1]^[x];
        if (Abs(C1.R - C2.R) > MAbweichung) or (Abs(C1.G - C2.G) > MAbweichung) or (Abs(C1.B - C2.B) > MAbweichung) then FoundPoint := false;
       end;
      end;
      LastLower := k;

      k := y;
      for j := y downto 0 do begin
       C1 := Lines1[j]^[i];
       if (not _IsPartOfPoint) then break
       else begin
        if (j < LastUpper) then begin
         C1 := Lines1[j]^[i-1];
         if (_IsPartOfPoint) then FoundPoint := false;
        end;
        k := j;
        if (j <> y) then inc(a);
       end;
      end;
      for j := j downto LastUpper do begin
       C1 := Lines1[j]^[i];
       if (_IsPartOfPoint) then FoundPoint := false;
      end;
      if (k <= Max.Y) then begin
       Max.Y := k;
       Max.X := i;
       if (_SelbeFarbe) and (Max.Y >= 1) then begin
        C1 := Lines1[Max.Y - 1]^[Max.X - 1];
        if (Abs(C1.R - C2.R) > MAbweichung) or (Abs(C1.G - C2.G) > MAbweichung) or (Abs(C1.B - C2.B) > MAbweichung) then FoundPoint := false;
       end;
      end;
      if (Max.X >= 0) and (i > Max.X) then begin
       if (k < LastUpper) then FoundPoint := false;
       if (_SelbeFarbe) and (k > LastUpper) then begin
        C1 := Lines1[LastUpper - 1]^[x];
        if (Abs(C1.R - C2.R) > MAbweichung) or (Abs(C1.G - C2.G) > MAbweichung) or (Abs(C1.B - C2.B) > MAbweichung) then FoundPoint := false;
       end;


      end;
      LastUpper := k;

      if (a > _Groesse) then FoundPoint := false;
      if (not FoundPoint) then break;
      C1 := Lines1[y]^[i];
      if (not _IsPartOfPoint) then break;
     end;

     if (Min.Y - Max.Y > i - x) then begin
      if (a * 3 < (Min.Y - Max.Y) * (Min.Y - Max.Y)) then FoundPoint := false;
     end else begin
      if (a * 3 < (i - x) * (i - x)) then FoundPoint := false;
     end;
     for j := LastUpper to LastLower do begin
      C1 := Lines1[j]^[i];
      if (_IsPartOfPoint) then FoundPoint := false;
     end;

     if (FoundPoint) then for i := x to Pic1.Width - 1 do begin
      C1 := Lines1[y]^[i];
      if (not _IsPartOfPoint) then break
      else begin
       for j := y to Pic1.Height - 1 do begin
        C1 := Lines1[j]^[i];
        if (not _IsPartOfPoint) then break
        else Lines1[j]^[i] := C2;
       end;
       for j := y downto 0 do begin
        C1 := Lines1[j]^[i];
        if (not _IsPartOfPoint) then break
        else Lines1[j]^[i] := C2;
       end;
      end;
     end;
    end;
   end;
  end;
  if (Pic1.Width > 2) then Progress.Position := Round(((y + 1) / (Pic1.Height) * 85 + 10) / 100 * Progress.Width);
  Application.ProcessMessages;
  if (not Operating) then begin Pic1.Free; exit; end;
 end;

 // Bild in Bitmap schreiben
 Progress.Position := Round(95 / 100 * Progress.Width);
 Result.Height := Pic1.Height;
 Result.Width := Pic1.Width;
 AssignOPBitmapToBitmap(Pic1,Result);
 Pic1.Free;
 Progress.Position := Progress.Width;
 Operating := false;
end;

procedure TPunktentferner.Show(Sender : TObject);
begin
 Box.DestroyComponents;

 Headline := TLabel.Create(Box);
 Headline.Parent := Box;
 Headline.Font.Name := 'Arial Black';
 Headline.Font.Size := 20;
 Headline.Left := 3;
 Headline.Top := 3;
 Headline.Caption := 'Schwarz-Addition';

 AbweichungL := TLabel.Create(Box);
 AbweichungL.Parent := Box;
 AbweichungL.AnchorToNeighbour(akTop,6,Headline);
 AbweichungL.Left := 20;
 AbweichungL.Caption := 'Farbabweichung:';

 AbweichungT := TTrackBar.Create(Box);
 AbweichungT.Parent := Box;
 AbweichungT.AnchorToNeighbour(akLeft,3,AbweichungL);
 AbweichungT.AnchorToNeighbour(akTop,5,Headline);
 AbweichungT.TickMarks := tmBoth;
 AbweichungT.TickStyle := tsNone;
 AbweichungT.Min := 0;
 AbweichungT.Max := 255;
 AbweichungT.Width := 150;
 AbweichungT.Position := Abweichung;
 AbweichungT.OnChange := @AbweichungTChange;

 AbweichungE := TEdit.Create(Box);
 AbweichungE.Parent := Box;
 AbweichungE.AnchorToNeighbour(akLeft,3,AbweichungT);
 AbweichungE.AnchorParallel(akTop,0,AbweichungT);
 AbweichungE.Width := 50;
 AbweichungE.Text := IntToStr(Abweichung);
 AbweichungE.OnChange := @AbweichungEChange;

 GroesseL := TLabel.Create(Box);
 GroesseL.Parent := Box;
 GroesseL.AnchorToNeighbour(akTop,6,AbweichungT);
 GroesseL.Left := 20;
 GroesseL.Caption := 'maximale Punktgroesse:';

 GroesseE := TEdit.Create(Box);
 GroesseE.Parent := Box;
 GroesseE.AnchorToNeighbour(akTop,5,AbweichungT);
 GroesseE.AnchorToNeighbour(akLeft,3,GroesseL);
 GroesseE.Width := 100;
 GroesseE.Text := IntToStr(Groesse);
 GroesseE.OnChange := @GroesseEChange;

 SelbeFarbeC := TCheckBox.Create(Box);
 SelbeFarbeC.Parent := Box;
 SelbeFarbeC.AnchorToNeighbour(akTop,5,GroesseE);
 SelbeFarbeC.Left := 20;
 SelbeFarbeC.Caption := 'Punkt muss von der selben Farbe umgeben sein';
 SelbeFarbeC.Checked := SelbeFarbe;
 SelbeFarbeC.OnChange := @SelbeFarbeCChange;

 Start := TButton.Create(Box);
 Start.Parent := Box;
 Start.Left := 20;
 Start.AnchorToNeighbour(akTop,7,SelbeFarbeC);
 Start.Width := 130;
 Start.Caption := 'START (Ausgangsbild)';
 Start.Enabled := false;
 Start.OnClick := @StartClick;

 Progress := TProgressBar.Create(Box);
 Progress.Parent := Box;
 Progress.AnchorParallel(akTop,0,Start);
 Progress.AnchorToNeighbour(akLeft,3,Start);
 Progress.Width := 150;
 Progress.Max := Progress.Width;

 Actualize;
end;

procedure TPunktentferner.Actualize;
var P : integer;
begin
 if (not Assigned(Start)) then exit;
 Start.Enabled := true;
 P := TPosRead(PosRead)();
 if (P >= Length(Bitmaps^)) or (P < 0) then begin Start.Enabled := false; exit; end;
 if (not Assigned(Bitmaps^[P])) then Start.Enabled := false;
 Pos := P;
end;

procedure TPunktentferner.InputColor(Color : BGRAColor);
begin
end;

procedure TPunktentferner.AbweichungEChange(Sender : TObject);
var i : integer;
begin
 i := EditToInt(AbweichungE);
 if (i > 255) or (i < 0) then begin AbweichungE.Color := $A0A0FF; exit; end;
 if (i <> AbweichungT.Position) then AbweichungT.Position := i;
 Abweichung := i;
end;

procedure TPunktentferner.AbweichungTChange(Sender : TObject);
var i : integer;
begin
 i := EditToInt(AbweichungE);
 if (i <> AbweichungT.Position) then AbweichungE.Text := IntToStr(AbweichungT.Position);
 Abweichung := AbweichungT.Position;
end;

procedure TPunktEntferner.GroesseEChange(Sender : TObject);
var i : integer;
begin
 i := EditToInt(GroesseE);
 if (i < 0) then begin GroesseE.Color := $A0A0FF; exit; end;
 Groesse := i;
end;

procedure TPunktEntferner.SelbeFarbeCChange(Sender : TObject);
begin
 SelbeFarbe := SelbeFarbeC.Checked;
end;

procedure TPunktentferner.StartClick(Sender : TObject);
var
 i : integer;
 C : BGRAColor;
begin
 for i := Pos + 1 to Length(Bitmaps^) - 1 do Bitmaps^[i].Free;
 SetLength(Bitmaps^,Pos + 2);
 C.R := 0;
 C.G := 0;
 C.B := 0;
 C.A := 255;
 Bitmaps^[Pos + 1] := DoFilter(Bitmaps^[Pos],Abweichung,50,Groesse,true,SelbeFarbe,C);
 if (Closed) then exit;
 TPosWrite(PosWrite)(Pos + 1);
end;

procedure TPunktentferner.Free;
begin
 Closed := true;
 Operating := false;
 inherited Free;
end;

initialization
{$I Punktentferner.lrs}

end.

